unit uClipping;

interface
  uses uReta, uWindow, uPonto, uMain, SysUtils, Dialogs;

type
  TClipping = class
  private
    procedure calculaDadosReta(pi, pf: tponto; window: twindow);
    procedure calculaCodigoRegiao(pi, pf: tponto; window: Twindow);
    procedure colocaPontosNaOrdemX(pi,pf : tponto;var r: treta; window: twindow);
    procedure colocaPontosNaOrdemY(pi,pf : tponto;var r: treta; window: twindow);
    procedure reduzCodigo(window: twindow);
    function retaEstaFora(pi, pf: tponto; window: twindow): boolean;
  protected
  public
    function clippingPonto(ponto: TPonto; Window: TWindow) : boolean;
    function clippingReta(reta: TReta; Window: TWindow;var r:TReta): boolean;
    constructor crie_se();
    destructor destrua_se;
  end;

implementation

var

  tcodigo,tcodigo2 : integer;
  codigo,codigo2 : integer;
  m,xE,xD,yT,yB: real;

{ TClipping }

function TClipping.clippingPonto(ponto: TPonto; Window: TWindow) : boolean;
begin
    result:=true;
    with ponto do begin
      if not((x>=Window.xmin) and (x<=Window.xmax) and
             (y>=Window.ymin) and (y<=Window.ymax)) then result:=false;
   end; //with
end;

function TClipping.clippingReta(reta: TReta; Window : TWindow;var r:TReta): boolean;
var
 fora : boolean;
begin
    m:=0;
    codigo:=0;
    codigo2:=0;
    fora:=false;
   with reta do begin

        calculaCodigoRegiao(pi,pf,window);

        // Cria DisplayFile2
        if ((codigo and codigo2) <> 0) then begin
          result:=false;
        end
        else
        if (codigo = 0) and (codigo2 = 0) then begin // completamente dentro
          r:=TReta.crie_se(nome, nil,nil);
          r.pi:=TPonto.crie_se('', pi.x, pi.y, pi.z);
          r.pf:=TPonto.crie_se('', pf.x, pf.y, pf.z);

          result:=true;
        end
        else
        begin
          if (codigo <> codigo2) then
            if ((codigo and codigo2) = 0) then begin //parcialmente
              r:=TReta.crie_se(nome, nil,nil);
              calculaDadosReta(pi,pf,window);
              colocaPontosNaOrdemX(pi,pf,r, window);

              if (tcodigo2=2) or (tcodigo=1) then begin
                if (tcodigo2=2) then begin
                  r.pf.x:=Window.xmax-1;
                  if r.pi.y < r.pf.y then r.pf.y:=yT
                  else r.pf.y:=yB;

                  if (tcodigo=4) then begin //reta com dois pontos de interseccao
                    r.pi.y:=Window.ymin+1;
                    if r.pi.x < r.pf.x then r.pi.x:=xE
                    else r.pi.x:=xD;
                  end;

                  if tcodigo=8 then begin //reta com dois pontos de interseccao
                    r.pi.y:=Window.ymax-1;
                    if r.pi.x < r.pf.x then r.pi.x:=xE
                    else r.pi.x:=xD;
                 end;

                 fora:=retaEstaFora(r.pi,r.pf,window);
               end;

                if tcodigo=1 then begin
                  r.pi.x:=Window.xmin+1;
                  if r.pi.y < r.pf.y then r.pi.y:=yB
                  else r.pi.y:=yT;

                  if tcodigo2=4 then begin //reta com dois pontos de interseccao
                    r.pf.y:=Window.ymin+1;
                    if r.pi.x < r.pf.x then r.pf.x:=xD
                    else r.pf.x:=xE;
                  end;

                  if tcodigo2=8 then begin //reta com dois pontos de interseccao
                    r.pf.y:=Window.ymax-1;
                    if r.pi.x < r.pf.x then r.pf.x:=xD
                    else r.pf.x:=xE;
                  end;

                  fora:=retaEstaFora(r.pi,r.pf,window);
                end
              end
              else begin
                colocaPontosNaOrdemY(pi,pf,r,window);
                if (tcodigo2=8) then begin
                  r.pf.y:=Window.ymax-1;
                  if r.pi.x < r.pf.x then r.pf.x:=xD
                  else r.pf.x:=xE;
                end;

                if (tcodigo=4) then begin
                  r.pi.y:=Window.ymin+1;
                  if r.pi.x < r.pf.x then r.pi.x:=xE
                  else r.pi.x:=xD;
                end;
              end;

              result:=not fora;

           end;
        end;
   end; //with

end;

constructor TClipping.crie_se;
begin
  xE:=99;
  xD:=99;
  yT:=99;
  yB:=99;
end;

destructor TClipping.destrua_se;
begin

end;

//calcula m, xE,xD, yB, yT
procedure TClipping.calculaDadosReta(pi,pf : tponto; window : twindow);
var
 t:real;
begin
              if (pf.x - pi.x)<>0 then begin
                m:=(pf.y - pi.y) / (pf.x - pi.x);
                yB:=m*(Window.xmin - pi.x) + pi.y; //xESQ
                yT:=m*(Window.xmax - pi.x) + pi.y; //xDIR
                if m<>0 then begin
                  xE:=(Window.ymin - pi.y)/m + pi.x; //yESQ
                  xD:=(Window.ymax - pi.y)/m + pi.x; //yDIR
                end;
              end
              else begin //reta vertical
                xE:=pi.x;
                xD:=pi.x;
              end;

              //corrige a interseco
              if xE > xD then begin
                t:=xD;
                xD:=xE;
                xE:=t;
              end;
              if yB > yT then begin
                t:=yT;
                yT:=yB;
                yB:=t;
              end;
end;

procedure TClipping.calculaCodigoRegiao(pi,pf : tponto; window : Twindow);
begin
        if pi.x > Window.xmax then codigo:=2;
        if pi.x < Window.xmin then codigo:=codigo+1;
        if pi.y > Window.ymax then codigo:=codigo+8;
        if pi.y < Window.ymin then codigo:=codigo+4;

        if pf.x > Window.xmax then codigo2:=2;
        if pf.x < Window.xmin then codigo2:=codigo2+1;
        if pf.y > Window.ymax then codigo2:=codigo2+8;
        if pf.y < Window.ymin then codigo2:=codigo2+4;
end;

procedure TClipping.colocaPontosNaOrdemX(pi,pf : tponto; var r : treta; window:twindow);
begin
    if  (pf.x >= pi.x) then begin
     tcodigo:=codigo;
     tcodigo2:=codigo2;
     r.pi:=Tponto.crie_se('',pi.x,pi.y,pi.z);
     r.pf:=Tponto.crie_se('',pf.x,pf.y,pf.z);
    end
    else
    begin
     tcodigo2:=codigo;
     tcodigo:=codigo2;
      r.pi:=Tponto.crie_se('',pf.x,pf.y,pf.z);
      r.pf:=Tponto.crie_se('',pi.x,pi.y,pi.z);
    end;
    reduzCodigo(window);
end;

procedure TClipping.colocaPontosNaOrdemY(pi,pf : tponto; var r : treta; window: twindow);
begin
    if  (pf.y >= pi.y) then begin
     tcodigo:=codigo;
     tcodigo2:=codigo2;
     r.pi:=Tponto.crie_se('',pi.x,pi.y,pi.z);
     r.pf:=Tponto.crie_se('',pf.x,pf.y,pf.z);
    end
    else
    begin
      tcodigo:=codigo2;
      tcodigo2:=codigo;
      r.pi:=Tponto.crie_se('',pf.x,pf.y,pf.z);
      r.pf:=Tponto.crie_se('',pi.x,pi.y,pi.z);
    end;
   reduzCodigo(window);
end;

procedure TClipping.reduzCodigo(window : twindow);
begin
    if tcodigo2=10 then begin
      if (xD > Window.xmin) and (xD < Window.xmax) then
       tcodigo2:=8
      else tcodigo2:=2;
    end
    else
    if tcodigo=5 then begin
      if (xE > Window.xmin) and (xE < Window.xmax) then tcodigo:=4
      else tcodigo:=1;
    end
    else
    if (tcodigo=9) or (tcodigo2=9) then begin
      if (xE > Window.xmin) and (xE < Window.xmax) then tcodigo2:=8
      else tcodigo:=1;
    end
    else
    if (tcodigo=6) or (tcodigo2=6) then begin
      if (xD > Window.xmin) and (xD < Window.xmax) then tcodigo:=4
       else tcodigo2:=2;
    end;
end;

function TClipping.retaEstaFora(pi,pf : tponto; window : twindow): boolean;
begin
 if (not clippingPonto(pi,window)) and
    (not clippingPonto(pf,window)) then result:=true
    else result:=false;
end;

end.
