
unit uMain;

interface

uses
  Windows, Controls, Forms, SysUtils, ExtCtrls, StdCtrls, Classes,
  Dialogs, uObjeto, uPonto, uReta, Graphics, uMatriz, uWindow, uBezier, uSpline, uObjeto3d,
   uSuperficie;


type
  TFormMain = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ListDisplayFile: TListBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    btIncluir: TButton;
    ViewPort: TImage;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ButtonZoomOut: TButton;
    ButtonZoomIn: TButton;
    ButtonTranslada: TButton;
    Button1: TButton;
    Button6: TButton;
    GroupBox6: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    RadioGroup1: TRadioGroup;
    procedure btIncluirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListDisplayFileKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ButtonTransladaClick(Sender: TObject);
    procedure ButtonZoomOutClick(Sender: TObject);
    procedure ButtonZoomInClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    Window : TWindow;
    isPerspectiva : boolean;
    dist : real;
    procedure atualizarListDisplayFile;
    procedure redesenhar;
    procedure TransformadaViewport(x,y:real; var vpx,vpy:real);
    procedure deletaObjeto;
    procedure DesenhaReta(pi, pf: TPonto);
    procedure Clipping;
    procedure DesenhaPonto(x, y: real);
    procedure DesenhaBezier(b: TBezier);
    procedure DesenhaSpline(s: TSpline);
    procedure DesenhaWireFrame(wf: TObjeto3d);
    function projecaoPersp(ponto : TPonto) : TPonto;
    function clipReta(reta : TReta; var aparece : boolean) : TReta;
    procedure DesenhaSuperficie(s: TSuperficie);
  public
    DisplayFile, df2: array[1..30] of TObjeto;
    nDisplayFile, ndf2 : integer;
  end;

var
  FormMain: TFormMain;

implementation

uses uFormIncluirObjetos,uFormTransformarObjetos, uPoligono, uClipping;

var
      VPxmin: integer;
      VPxmax: integer;
      VPymin: integer;
      VPymax: integer;

{$R *.dfm}

procedure TFormMain.btIncluirClick(Sender: TObject);
var
 pi,pf : TPonto;
 nome: string;
 x1,x2,y1,y2,z1,z2 : integer;
 i:integer;
begin

  FormIncluir.ComboBoxSuperficie.Clear;
  for i:=1 to nDisplayFile do
   if DisplayFile[i].ClassName = 'TSuperficie' then
     FormIncluir.ComboBoxSuperficie.Items.Add(DisplayFile[i].nome);
  FormIncluir.ComboBoxSuperficie.ItemIndex:=0;

 FormIncluir.ShowModal;
 if FormIncluir.ok then begin
   inc(nDisplayFile);
   nome:=FormIncluir.EditNome.Text;
   if FormIncluir.objeto = 'Ponto' then begin
      x1:=strtoint(FormIncluir.EditX.Text);
      y1:=strtoint(FormIncluir.EditY.Text);
      z1:=strtoint(FormIncluir.EditZ.Text);
      DisplayFile[nDisplayFile]:=TPonto.crie_se(nome,x1,y1,z1);
   end
   else
   if FormIncluir.objeto = 'Reta' then begin
      x1:=strtoint(FormIncluir.EditX1.Text);
      y1:=strtoint(FormIncluir.EditY1.Text);
      z1:=strtoint(FormIncluir.EditZ1.Text);
      x2:=strtoint(FormIncluir.EditX2.Text);
      y2:=strtoint(FormIncluir.EditY2.Text);
      z2:=strtoint(FormIncluir.EditZ2.Text);
      pi:=TPonto.crie_se(nome,x1,y1,z1);
      pf:=TPonto.crie_se(nome,x2,y2,z2);
      DisplayFile[nDisplayFile]:=TReta.crie_se(nome,pi,pf);
   end
   else
   if FormIncluir.objeto = 'Poligono' then begin
      DisplayFile[nDisplayFile]:=TPoligono.crie_se(nome);
    for i:=1 to 10 do begin
      if FormIncluir.SGPoligono.Cells[1,i] <> '' then begin
        x1:=strtoint(FormIncluir.SGPoligono.Cells[1,i]);
        y1:=strtoint(FormIncluir.SGPoligono.Cells[2,i]);
        z1:=strtoint(FormIncluir.SGPoligono.Cells[3,i]);
        TPoligono(DisplayFile[nDisplayFile]).adicionaPonto(x1,y1,z1);
      end;
    end;
   end
   else
   if FormIncluir.objeto = 'Bezier' then begin
      DisplayFile[nDisplayFile] := TBezier.crie_se(nome);
    for i:=1 to 4 do begin
      x1:=strtoint(FormIncluir.SGBezier.Cells[1,i]);
      y1:=strtoint(FormIncluir.SGBezier.Cells[2,i]);
      z1:=strtoint(FormIncluir.SGBezier.Cells[3,i]);
      TBezier(DisplayFile[nDisplayFile]).adicionaPonto(x1,y1,z1);
    end;
   end
   else
   if FormIncluir.objeto = 'Spline' then begin
      DisplayFile[nDisplayFile] := TSpline.crie_se(nome);
    for i:=1 to 10 do begin
      if FormIncluir.SGSpline.Cells[1,i] <> '' then begin
        x1:=strtoint(FormIncluir.SGSpline.Cells[1,i]);
        y1:=strtoint(FormIncluir.SGSpline.Cells[2,i]);
        z1:=strtoint(FormIncluir.SGSpline.Cells[3,i]);
        TSpline(DisplayFile[nDisplayFile]).adicionaPonto(x1,y1,z1);
      end;
    end;
   end
   else
   if FormIncluir.objeto = 'WireFrame' then begin
      DisplayFile[nDisplayFile] := TObjeto3d.crie_se(nome, FormIncluir.nwireframe);
      TObjeto3d(DisplayFile[nDisplayFile]).setaPontos(FormIncluir.wireframe);
   end
   else
   if FormIncluir.objeto = 'Superficie' then begin
    DisplayFile[nDisplayFile] := TSuperficie.crie_se(nome);
    for i:=1 to 16 do begin
      if FormIncluir.SGSuperficie.Cells[1,i] <> '' then begin
        x1:=strtoint(FormIncluir.SGSuperficie.Cells[1,i]);
        y1:=strtoint(FormIncluir.SGSuperficie.Cells[2,i]);
        z1:=strtoint(FormIncluir.SGSuperficie.Cells[3,i]);
        TSuperficie(DisplayFile[nDisplayFile]).setaPonto(i,x1,y1,z1);
      end;
    end;
   end;
   DisplayFile[nDisplayFile].translada(0,0,dist);
   atualizarListDisplayFile;
   redesenhar;
 end;

end;

procedure TFormMain.FormCreate(Sender: TObject);
var
 p1, p2: TPonto;
begin
 isPerspectiva := false;
 dist := 0;
 nDisplayFile :=0;

 VPxmin:=10;
 VPxmax:=ViewPort.Width-10;
 VPymin:=10;
 VPymax:=viewport.Height-10;

 Window:=TWindow.crie_se(-VPxmax/2,VPxmax/2,-VPymax/2,VPymax/2);

 viewport.Canvas.Pen.Color:=clBlack;
 //eixo X
 p1:=TPonto.crie_se('',-200,0,0);
 p2:=TPonto.crie_se('',200,0,0);
 inc(nDisplayFile);
 DisplayFile[nDisplayFile]:=TReta.crie_se('Eixo X',p1,p2);

  //eixo Y
 p1:=TPonto.crie_se('',0,-200,0);
 p2:=TPonto.crie_se('',0,200,0);
 inc(nDisplayFile);
 DisplayFile[nDisplayFile]:=TReta.crie_se('Eixo Y',p1,p2);

 viewport.Canvas.Pen.Color:=clBlue;
 viewport.Canvas.Brush.Color:=clWhite;
 viewport.Canvas.Rectangle(10,10,ViewPort.Width-10,ViewPort.Height-10);

 atualizarListDisplayFile;
 redesenhar;
end;

procedure TFormMain.atualizarListDisplayFile;
var
   i:integer;
begin
        ListDisplayFile.Items.Clear;
        for i:=1 to nDisplayFile do
           ListDisplayFile.Items.Add(DisplayFile[i].tipo +'('+ DisplayFile[i].nome + ')');
end;

procedure TFormMain.redesenhar;
var
 i : integer;
begin

 Clipping;

 viewport.Canvas.Brush.Color:=clWhite;
 viewport.Canvas.FillRect(Rect(11,11,ViewPort.Width-11,ViewPort.Height-11));

 for i:=1 to ndf2 do begin

   if copy(df2[i].nome,1,4)='Eixo' then viewport.Canvas.Pen.Color:=clGreen
   else viewport.Canvas.Pen.Color:=clBlack;

   if df2[i].ClassName = 'TPonto' then begin
     viewport.Canvas.Pen.Color:=clRed;
     DesenhaPonto(TPonto(df2[i]).x, TPonto(df2[i]).y)
   end
   else
   if df2[i].ClassName = 'TReta' then
     DesenhaReta(TReta(df2[i]).pi, TReta(df2[i]).pf)
   else
   if df2[i].ClassName = 'TBezier' then
     DesenhaBezier(TBezier(df2[i]))
   else
   if df2[i].ClassName = 'TSpline' then
     DesenhaSpline(TSpline(df2[i]))
   else
   if df2[i].ClassName = 'TObjeto3d' then
     DesenhaWireFrame(TObjeto3d(df2[i]))
   else
   if df2[i].ClassName = 'TSuperficie' then
     DesenhaSuperficie(TSuperficie(df2[i]))
 end;
end;

procedure TFormMain.TransformadaViewport(x,y:real; var vpx,vpy:real);
begin
     vpx:=vpxmin + (((vpxmax - vpxmin)/(Window.xmax - Window.xmin))*(x-Window.xmin));
     vpy:=vpymax - (((vpymax - vpymin)/(Window.ymax - Window.ymin))*(y-Window.ymin));
end;


procedure TFormMain.DesenhaPonto(x,y:real);
var
  vpx, vpy : real;
begin
   TransformadaViewport(x,y,vpx,vpy);
   ViewPort.Canvas.Ellipse(round(vpx-2),round(vpy-2),round(vpx+2),round(vpy+2));
end;

procedure TFormMain.DesenhaReta(pi, pf: TPonto);
var
  vpx1, vpy1,vpx2,vpy2 : real;
begin
   TransformadaViewport(pi.x,pi.y,vpx1,vpy1);
   TransformadaViewport(pf.x,pf.y,vpx2,vpy2);
   ViewPort.Canvas.Polygon([point(round(vpx1),round(vpy1)),point(round(vpx2),round(vpy2))]);
end;

procedure TFormMain.DesenhaSpline(s : TSpline);
var
 i,j : integer;
 k: integer;
 pontos : TMatriz;
 pi,pf : tponto;
 clipar : TClipping;
 reta: TReta;
 ponto, nPonto, nPontof : TPonto;
 aparece : boolean;
begin

 viewport.Canvas.Pen.Color:=clMaroon;

  for i := 1 to s.npontos do begin
    pi := s.getPonto(i);
    if(pi.z>=dist) then begin
       if(isPerspectiva) then pi := projecaoPersp(pi);
       if clipar.clippingPonto(pi, window) then desenhaPonto(pi.x,pi.y);
    end;
  end;

  viewport.Canvas.Pen.Color:=clSkyBlue;
  k := 50;
  i:=1;
  reta := Treta.crie_se('',nil,nil);
  pi := TPonto.crie_se('',0,0,0);
  pf := TPonto.crie_se('',0,0,0);
  while i <= (s.npontos-3) do
  begin
     pontos := s.MatrizPontosSpline(i,k);
     for j := 1 to k do begin

       pi.x := pontos.retornaValor(1,j);
       pi.y := pontos.retornaValor(2,j);
       pi.z := pontos.retornaValor(3,j);

       pf.x := pontos.retornaValor(1,j+1);
       pf.y := pontos.retornaValor(2,j+1);
       pf.z := pontos.retornaValor(3,j+1);

       reta.pi := pi;
       reta.pf := pf;
       reta := clipReta(reta,aparece);
       
       if aparece then begin
          if isPerspectiva then begin
            ponto := reta.pi;
            nPonto := projecaoPersp(ponto);
            ponto := reta.pf;
            nPontof := projecaoPersp(ponto);
            reta.pi := nPonto;
            reta.pf := nPontof;
          end;
          if clipar.clippingReta(reta,window,reta) then DesenhaReta(reta.pi,reta.pf);
       end;
     end;
     i := i + 1;
   end;
end;

procedure TFormMain.DesenhaBezier(b : TBezier);
var
 i : real;
 pi,pf: TPonto;
 t: real;
 clipar : TClipping;
 reta, nreta : Treta;
 aparece : boolean;
begin
 viewport.Canvas.Pen.Color:=clPurple;
 clipar:=TClipping.crie_se;
 if isPerspectiva then
    nreta := TReta.crie_se('',self.projecaoPersp(b.getPonto(1)),self.projecaoPersp(b.getPonto(2)))
 else
    nreta := TReta.crie_se('',b.getPonto(1),b.getPonto(2));
 nreta := self.clipReta(nreta, aparece);
 if aparece then
    if clipar.clippingReta(nreta,window,reta) then
       DesenhaReta(reta.pi,reta.pf);
 if isPerspectiva then
    nreta := TReta.crie_se('',self.projecaoPersp(b.getPonto(3)),self.projecaoPersp(b.getPonto(4)))
 else
    nreta := TReta.crie_se('',b.getPonto(3),b.getPonto(4));
 nreta := self.clipReta(nreta, aparece);
 if aparece then
    if clipar.clippingReta(nreta,window,reta) then
      DesenhaReta(reta.pi,reta.pf);

{ viewport.Canvas.Pen.Color:=clSkyBlue;}
 t:=(-window.xmin+window.xmax)*0.00005;
 i:=0;
 pi:=b.ValorBezier(i);
 nreta := TReta.crie_se('',nil,nil);
 while i<1 do begin
  pf:=b.ValorBezier(i+t);
  if isPerspectiva then begin
     nreta.pi := self.projecaoPersp(pi);
     nreta.pf := self.projecaoPersp(pf);
  end else begin
     nreta.pi := pi;
     nreta.pf := pf;
  end;
  nreta := clipReta(nreta,aparece);
  if aparece then
     if clipar.clippingReta(nreta,window,reta) then DesenhaReta(reta.pi,reta.pf);
  i:=t+i;
  pi:=pf;
 end;

end;

procedure TFormMain.ListDisplayFileKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=46 then deletaObjeto
  else if key=45 then btIncluirClick(nil);
end;

procedure TFormMain.deletaObjeto;
var
 i:integer;
begin
 if ListDisplayFile.ItemIndex = -1 then exit;

 for i:=ListDisplayFile.ItemIndex+1 to nDisplayFile do DisplayFile[i]:=DisplayFile[i+1];
 dec(nDisplayFile);
 atualizarListDisplayFile;
 redesenhar;
end;

procedure TFormMain.Button3Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(-10,0,0);
   redesenhar;
end;

procedure TFormMain.Button4Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(10,0,0);
   redesenhar;
end;

procedure TFormMain.Button2Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(0,-10,0);
   redesenhar;
end;

procedure TFormMain.Button5Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(0,10,0);
   redesenhar;
end;

procedure TFormMain.ButtonTransladaClick(Sender: TObject);
var
 x,y,z : real;
 tipoRotacao, eixoRotacao: integer;
 index, anguloRotacao: integer;
begin
 index:=ListDisplayFile.ItemIndex+1;
 if index=0 then begin
   showmessage('Nenhum objeto foi selecionado!');
   exit;
 end;

 FormTransform.ShowModal;
 if FormTransform.ok then begin
   if FormTransform.tipo = 'Translacao' then begin
      x:=strtoint(FormTransform.EditDx.Text);
      y:=strtoint(FormTransform.EditDy.Text);
      z:=strtoint(FormTransform.EditDz.Text);
      DisplayFile[index].translada(x,y,z);
   end
   else
   if FormTransform.tipo = 'Escalona' then begin
      x:=strtofloat(FormTransform.EditSx.Text);
      y:=strtofloat(FormTransform.EditSy.Text);
      z:=strtofloat(FormTransform.EditSz.Text);
      DisplayFile[index].escalona(FormTransform.CheckBoxOrigem.Checked,x,y,z);
   end
   else
   if FormTransform.tipo = 'Rotacao' then begin
      tipoRotacao:=FormTransform.RadioGroupTipoRotacao.ItemIndex;
      eixoRotacao:=FormTransform.RadioGroupEixoRotacao.ItemIndex;
      anguloRotacao:=strtoint(FormTransform.EditAngulo.Text);
      DisplayFile[index].rotacao(tipoRotacao, eixoRotacao, anguloRotacao);
   end;
  redesenhar;
 end;
end;

procedure TFormMain.ButtonZoomInClick(Sender: TObject);
begin
 Window.Xmax:=Window.Xmax-20;
 Window.Ymax:=Window.Ymax-20;
 Window.Xmin:=Window.Xmin+20;
 Window.Ymin:=Window.Ymin+20;

  if not Window.erro then redesenhar
  else
  begin
   showmessage('Limite j alcanado');
   ButtonZoomOutClick(nil);
  end;

end;

procedure TFormMain.ButtonZoomOutClick(Sender: TObject);
begin
 Window.Xmax:=Window.Xmax+20;
 Window.Ymax:=Window.Ymax+20;
 Window.Xmin:=Window.Xmin-20;
 Window.Ymin:=Window.Ymin-20;

  if not Window.erro then redesenhar
  else
  begin
   showmessage('Limite j alcanado');
   ButtonZoomInClick(nil);
  end;
end;

procedure TFormMain.Clipping;
var
 i,j,k : integer;
 clipar : TClipping;
 reta, nReta : TReta;
 ponto,nPonto, nPontof : TPonto;
 aparece : boolean;
begin

 clipar:=TClipping.crie_se;
 ndf2 :=0;
 for i:=1 to nDisplayFile do begin
   if DisplayFile[i].ClassName = 'TPonto' then begin
      ponto := TPonto(DisplayFile[i]);
      if(ponto.z>=dist) then begin
         if(isPerspectiva) then begin
            nPonto := projecaoPersp(ponto);
            if clipar.clippingPonto(nPonto, window) then begin
                inc(ndf2);
                df2[ndf2]:= nPonto;
            end;
         end else begin
            if clipar.clippingPonto(ponto, window) then begin
              inc(ndf2);
              df2[ndf2]:= ponto;
            end;
         end;
      end;
   end
   else
   if DisplayFile[i].ClassName = 'TReta' then begin
      if(not isPerspectiva) then begin
         reta := clipReta(TReta(DisplayFile[i]),aparece);
         if (aparece) then
            if clipar.clippingReta(reta,window,TReta(df2[ndf2+1])) then
               inc(ndf2);
      end else begin
         reta := clipReta(TReta(DisplayFile[i]),aparece);
         if(aparece) then begin
            ponto := reta.pi;
            nPonto := projecaoPersp(ponto);
            ponto := reta.pf;
            nPontof := projecaoPersp(ponto);
            nReta := TReta.crie_se('Reta',nPonto,nPontof);
            if clipar.clippingReta(nReta,window,TReta(df2[ndf2+1])) then
               inc(ndf2);
         end;
      end;
   end
   else
   if DisplayFile[i].ClassName = 'TPoligono' then begin
       k:=TPoligono(DisplayFile[i]).npontos;
       if(not isPerspectiva) then begin
          for j:= 1 to k do begin
            reta:=TReta.crie_se('',
                 TPoligono(DisplayFile[i]).getPonto(j),TPoligono(DisplayFile[i]).getPonto( ((j+1) mod (k+1)) + ((j+1) div (k+1)) ));
            reta := clipReta(reta,aparece);
            if (aparece) then
               if clipar.clippingReta(reta,window,TReta(df2[ndf2+1])) then inc(ndf2);
          end;
       end else begin
          for j:= 1 to k do begin
            reta:=TReta.crie_se('',
                 TPoligono(DisplayFile[i]).getPonto(j),TPoligono(DisplayFile[i]).getPonto( ((j+1) mod (k+1)) + ((j+1) div (k+1)) ));
            reta := clipReta(reta,aparece);
            if (aparece) then begin
               ponto := reta.pi;
               nPonto := projecaoPersp(ponto);
               ponto := reta.pf;
               nPontof := projecaoPersp(ponto);
               nReta := TReta.crie_se('Reta',nPonto,nPontof);
               if clipar.clippingReta(nReta,window,TReta(df2[ndf2+1])) then
                  inc(ndf2);
            end;
          end;
       end;
   end
   else
   if (DisplayFile[i].ClassName = 'TBezier') or (DisplayFile[i].ClassName = 'TSpline') then begin
     df2[ndf2+1]:=DisplayFile[i];
     inc(ndf2);
   end
   else
   if (DisplayFile[i].ClassName = 'TObjeto3d') then begin
     df2[ndf2+1]:=DisplayFile[i];
     inc(ndf2);
   end
   else
   if (DisplayFile[i].ClassName = 'TSuperficie') then begin
     df2[ndf2+1]:=DisplayFile[i];
     inc(ndf2);
   end;

end; //for

end;

procedure TFormMain.DesenhaSuperficie(s : TSuperficie);
var
   lista, linha : Tlist;
   i,j: integer;
   ponto1,ponto2, ponto3,NPOnto,nPontof : TPonto;
   reta : TReta;
   aparece : boolean;
   clipar : TClipping;
begin
   clipar := TClipping.crie_se();
   lista := s.matrizRetas(10,10,50);
   reta := Treta.crie_se('',nil,nil);
   for i:=0 to lista.count-1 do begin
      linha := lista.items[i];
      ponto1 := linha.items[0];
      for j:=1 to linha.count-1 do begin
         ponto2 := linha.items[j];
         if(not isPerspectiva) then begin
            reta := clipReta(TReta.crie_se('',ponto1,ponto2),aparece);
            if (aparece) then
               if clipar.clippingReta(reta,window,reta) then DesenhaReta(reta.pi,reta.pf);
         end else begin
            reta.pi := ponto1;
            reta.pf := ponto2;
            reta := clipReta(reta,aparece);
            if(aparece) then begin
               ponto3 := reta.pi;
               nPonto := projecaoPersp(ponto3);
               ponto3 := reta.pf;
               nPontof := projecaoPersp(ponto3);
               reta.pi := nPonto;
               reta.pf := nPontof;
               if clipar.clippingReta(reta,window,reta) then DesenhaReta(reta.pi,reta.pf);
            end;
         end;
         ponto1 := ponto2;
      end;
   end;
end;

procedure TFormMain.DesenhaWireFrame(wf: TObjeto3d);
var
 ponto, ponto2, ponto3, nPonto, nPontof : TPonto;
 clipar : TClipping;
 ligPonto : TMatriz;
 i,j,n : integer;
 reta : TReta;
 aparece : boolean;
begin
   clipar := TClipping.crie_se();
   reta := TReta.crie_se('',nil,nil);
   for i:= 1 to wf.getNPontos() do begin
      ponto := wf.getPonto(i);
      ligPonto := wf.getArestas(i);
      n := ligPonto.ncolunas;
      for j:=1 to n do begin
         ponto2 := wf.getPonto(Trunc(ligPonto.retornaValor(1,j)));
         reta.pi := ponto;
         reta.pf := ponto2;
         reta := clipReta(reta,aparece);
         if(not isPerspectiva) then begin
            if (aparece) then
               if clipar.clippingReta(reta,window,reta) then DesenhaReta(reta.pi,reta.pf);
         end else begin
            if(aparece) then begin
               ponto3 := reta.pi;
               nPonto := projecaoPersp(ponto3);
               ponto3 := reta.pf;
               nPontof := projecaoPersp(ponto3);
               reta.pi := nponto;
               reta.pf := nPontof;
               ponto3.destrua_se;
              if clipar.clippingReta(reta,window,reta) then DesenhaReta(reta.pi,reta.pf);
            end;
         end;
      end;
   end;
end;

procedure TFormMain.Button1Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(0,0,-10);
   redesenhar();
end;

procedure TFormMain.Button6Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].translada(0,0,10);
   redesenhar();
end;

procedure TFormMain.Button9Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].rotacao(0,2,-strtoint(Edit1.text));
   redesenhar();
end;

procedure TFormMain.Button8Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].rotacao(0,1,-strtoint(Edit1.text));
   redesenhar();
end;

procedure TFormMain.Button7Click(Sender: TObject);
var i : integer;
begin
   for i := 1 to nDisplayFile do
      DisplayFile[i].rotacao(0,0,-strtoint(Edit1.text));
   redesenhar();
end;

procedure TFormMain.RadioGroup1Click(Sender: TObject);
var i : integer;
begin
   if(isPerspectiva and (RadioGroup1.ItemIndex=0)) then begin
      isPerspectiva := false;
      for i := 1 to nDisplayFile do
         DisplayFile[i].translada(0,0,-dist);
      dist := 0;
      redesenhar();
   end
   else begin
      if((not isPerspectiva) and (RadioGroup1.ItemIndex=1)) then begin
         isPerspectiva := true;
         dist := 50;
         for i := 1 to nDisplayFile do
            DisplayFile[i].translada(0,0,dist);
         redesenhar();
      end;
   end;
end;

function TFormMain.projecaoPersp(ponto : TPonto) : TPonto;
begin
   Result := TPonto.crie_se('PontoF',ponto.x/(ponto.z/dist),ponto.y/(ponto.z/dist),ponto.z);
end;

function TFormMain.clipReta(reta : TReta; var aparece : boolean) : TReta;
var
   ponto, nPontoi, nPontof : TPonto;
   x,y : real;
begin
   ponto := reta.pi;
   if(ponto.z>=dist)then begin
      nPontoi := TPonto.crie_se('',ponto.x,ponto.y,ponto.z);
      ponto := reta.pf;
      if(ponto.z>=dist)then begin
         nPontof := TPonto.crie_se('',ponto.x,ponto.y,ponto.z);
      end else begin
         x := (abs(nPontoi.z) * (abs(ponto.x) - abs(nPontoi.x)))/(abs(nPontoi.z) + abs(ponto.z));
         y := (abs(nPontoi.z) * (abs(ponto.y) - abs(nPontoi.y)))/(abs(nPontoi.z) + abs(ponto.z));
         if(nPontoi.x>=0) then x := x + nPontoi.x
         else x := nPontoi.x - x;
         if(nPontoi.y>=0) then y := y + nPontoi.y
         else y := nPontoi.y - y;
         nPontof := TPonto.crie_se('',x,y,dist);
      end;
      aparece := true;
      Result := TReta.crie_se('',nPontoi,nPontof);
   end else begin
      ponto := reta.pf;
      if (ponto.z>=dist) then begin
         nPontoi := TPonto.crie_se('',ponto.x,ponto.y,ponto.z);
         ponto := reta.pi;
         x := (abs(nPontoi.z) * (abs(ponto.x) - abs(nPontoi.x)))/(abs(nPontoi.z) + abs(ponto.z));
         y := (abs(nPontoi.z) * (abs(ponto.y) - abs(nPontoi.y)))/(abs(nPontoi.z) + abs(ponto.z));
         if(nPontoi.x>=0) then x := x + nPontoi.x
         else x := nPontoi.x - x;
         if(nPontoi.y>=0) then y := y + nPontoi.y
         else y := nPontoi.y - y;
         nPontof := TPonto.crie_se('',x,y,dist);
         aparece := true;
         Result := TReta.crie_se('',nPontoi,nPontof);
      end
      else aparece := false;
   end;
end;




end.
