unit uMatriz;

interface

uses  Classes, Dialogs, SysUtils;

type

   Pelemento = ^aelemento;
   aelemento = record
     valor : real;
   end;

  TMatriz = class

  private
    matriz : tlist;
    vnlinhas, vncolunas : integer;
  public
    function retornaValor(i, j: integer): real;
    class function multiplicaMatriz(M1, M2: TMatriz): TMatriz;
    procedure setaValor(i, j: integer; _valor: real);
    constructor crie_se(_nlinhas,_ncolunas:integer);
    destructor destrua_se;
    function transposta : TMatriz;
  published
    property nlinhas: integer read vnlinhas write vnlinhas;
    property ncolunas: integer read vncolunas write vncolunas;

  end;

implementation

constructor TMatriz.crie_se(_nlinhas, _ncolunas: integer);
var
 elemento: Pelemento;
 i : integer;
begin

 nlinhas:=_nlinhas;
 ncolunas:=_ncolunas;

 //inicializa matriz
 matriz:=TList.Create;
 New(elemento);
 Elemento^.valor := 0;
 for i:= 1 to nlinhas*ncolunas do matriz.Add(elemento);
end;

destructor TMatriz.destrua_se;
begin
 matriz.free;
end;

class function TMatriz.multiplicaMatriz(M1,M2:TMatriz):TMatriz;
var
        Mr : TMatriz;
        i,j,k:integer;
begin
        if M1.ncolunas = M2.nlinhas then
        begin
          Mr:= TMatriz.crie_se(M1.nlinhas,M2.ncolunas);
          for i:=1 to M1.nlinhas do
            for j:=1 to M2.ncolunas do
              for k:=1 to M1.ncolunas do //ou M2.nlinhas
                 Mr.setaValor(i,j,
                   Mr.retornaValor(i,j)+M1.retornaValor(i,k)*M2.retornaValor(k,j));
          result:=Mr;
        end
        else begin
          showmessage('No  possvel fazer a multiplicao de AxB');
          result:=nil;
        end;
end;

function TMatriz.retornaValor(i,j : integer) : real;
var
 elemento: PElemento;
begin
    New(Elemento);
    Elemento:= matriz.items[ncolunas*(i-1) + (j-1)];
    result:=elemento^.valor;
end;

procedure TMatriz.setaValor(i, j : integer; _valor: real);
var
 elemento: PElemento;
begin
    New(elemento);
    Elemento^.valor := _valor;
    matriz.items[ncolunas*(i-1) + (j-1)]:=elemento;
end;

function TMatriz.transposta: TMatriz;
var i,j : integer;
    resp : TMatriz;
begin
   resp := TMatriz.crie_se(self.ncolunas,self.nlinhas);
   for i := 1 to self.nlinhas do
      for j :=1 to self.ncolunas do
         resp.setaValor(j,i,retornaValor(i,j));
   Result := resp;
end;

end.
