unit uPoligono;

interface

   uses UObjeto, UPonto, Dialogs, Classes;


   Type
     Pponto = ^aponto;
       aponto = record
         ponto : TPonto;
   end;

   type TPoligono=class(TObjeto)
  private
     vnpontos : integer;
    procedure setPonto(i: integer; x, y, z: real);
   protected
     poligono : Tlist;
   public
      function getPonto(i: integer): TPonto;
      procedure adicionaPonto(_x, _y, _z: integer);
      procedure rotacao(tipoRotacao,eixoRotacao,angulo: integer); override;
      procedure translada(dx,dy,dz: real); override;
      procedure escalona(origem: boolean; sx,sy,sz: real); override;
      constructor crie_se(_nome:String);
      destructor destrua_se;

   published
    property npontos: integer read vnpontos write vnpontos;

  end;

implementation

procedure TPoligono.adicionaPonto(_x, _y, _z: integer);
var
 ponto: Pponto;
begin
   New(ponto);
   ponto^.ponto:=TPonto.crie_se(nome,_x,_y,_z);
   poligono.Add(ponto);
   npontos:=npontos+1;
end;

constructor TPoligono.crie_se(_nome:String);
begin
   tipo:='Poligono';
   nome:=_nome;
   poligono:=TList.Create;
   npontos:=0;
end;

destructor TPoligono.destrua_se;
begin
end;

procedure TPoligono.escalona(origem: boolean; sx, sy, sz: real);
var
  i : integer;
  somaX, somaY, somaZ : real;
  dx, dy, dz : real;
begin

  if not origem then begin
     somaX := 0;
     somaY := 0;
     somaZ := 0;
     for i := 1 to npontos do begin
        somaX := somaX + getPonto(i).x;
        somaY := somaY + getPonto(i).y;
        somaZ := somaZ + getPonto(i).z;
     end;
     dx := somaX/npontos;
     dy := somaY/npontos;
     dz := somaZ/npontos;
     translada(-dx, -dy, -dz);
  end;
  for i := 1 to npontos do
     getPonto(i).escalona(true, sx, sy, sz);
  if not origem then translada(dx,dy,dz);

end;

function TPoligono.getPonto(i: integer): TPonto;
var
 ponto : Pponto;
begin
    New(ponto);
    ponto:= poligono.items[i-1];
    result:=ponto^.ponto;
end;

procedure TPoligono.setPonto(i:integer;x,y,z : real);
var
 ponto : Pponto;
begin
   New(ponto);
   ponto^.ponto:=TPonto.crie_se(nome,x,y,z);
   poligono.items[i-1]:=ponto;
end;

procedure TPoligono.rotacao(tipoRotacao, eixoRotacao, angulo: integer);
var
  i: integer;
  somaX, somaY, somaZ :real;
  dx, dy, dz : real;
begin
   if tipoRotacao=2 then begin
     somaX := 0;
     somaY := 0;
     somaZ := 0;
     for i := 1 to npontos do begin
        somaX := somaX + getPonto(i).x;
        somaY := somaY + getPonto(i).y;
        somaZ := somaZ + getPonto(i).z;
     end;
     dx := somaX/npontos;
     dy := somaY/npontos;
     dz := somaZ/npontos;
     translada(-dx, -dy, -dz);
   end;
   for i := 1 to npontos do
      getPonto(i).rotacao(0, eixorotacao, angulo);
   if tipoRotacao=2 then translada(dx,dy,dz);
end;

procedure TPoligono.translada(dx, dy, dz: real);
var
 i : integer;
begin
  for i := 1 to npontos do
    setPonto(i,getPonto(i).x+dx,getPonto(i).y+dy,getPonto(i).z+dz);
end;

end.
