unit UPonto;

interface
   uses UObjeto, Math, Dialogs, SysUtils;
   type TPonto=class(TObjeto)
   protected
      vx : real;
      vy : real;
      vz : real;
   public
      procedure rotacao(tipoRotacao,eixoRotacao,angulo: integer); override;
      procedure translada(dx,dy,dz: real); override;
      procedure escalona(origem: boolean; sx,sy,sz: real); override;
      destructor destrua_se;
    constructor crie_se(_nome: String; _x, _y, _z: real);

   published
     property x: real read vx write vx;
     property y: real read vy write vy;
     property z: real read vz write vz;
      end;

implementation

constructor TPonto.crie_se(_nome:String; _x,_y,_z:real);
begin
     tipo:='Ponto';
     x:=_x;
     y:=_y;
     z:=_z;
     nome:=_nome;
end;

destructor TPonto.destrua_se;
begin
end;

procedure TPonto.escalona(origem: boolean; sx, sy, sz: real);
begin
  if origem then begin
     x:=x*sx;
     y:=y*sy;
     z:=z*sz;
  end;
end;

procedure TPonto.rotacao(tipoRotacao, eixoRotacao, angulo: integer);
var tx, ty, tz : real;
begin
  if tipoRotacao = 0 then begin //sobre a origem
     if(eixoRotacao = 0) then begin
           tz := z;
           ty := y;
           z := tz*cos(DegToRad(angulo)) + ty*sin(DegToRad(angulo));
           y := -tz*sin(DegToRad(angulo)) + ty*cos(DegToRad(angulo));
     end
     else
        if(eixoRotacao = 1) then begin
           tx := x;
           tz := z;
           x := tx*cos(DegToRad(angulo)) + tz*sin(DegToRad(angulo));
           z := -tx*sin(DegToRad(angulo)) + tz*cos(DegToRad(angulo));
        end
        else begin
           tx := x;
           ty := y;
           x := tx*cos(DegToRad(angulo)) - ty*sin(DegToRad(angulo));
           y := tx*sin(DegToRad(angulo)) + ty*cos(DegToRad(angulo));
        end;
  end;
end;

procedure TPonto.translada(dx, dy, dz: real);
begin
  x:=x+dx;
  y:=y+dy;
  z:=z+dz;
end;

end.
