unit uReta;

interface

   uses UObjeto, UPonto, Dialogs;

   type TReta=class(TObjeto)
   protected
     vpi, vpf : TPonto;
   public
      procedure rotacao(tipoRotacao,eixoRotacao,angulo: integer); override;
      procedure translada(dx,dy,dz: real); override;
      procedure escalona(origem: boolean; sx,sy,sz: real); override;
      constructor crie_se(_nome:String;_pi,_pf : TPonto);
      destructor destrua_se;

   published
     property pi: TPonto read vpi write vpi;
     property pf: TPonto read vpf write vpf;

   end;

implementation

constructor TReta.crie_se(_nome:String;_pi,_pf : TPonto);
begin
     tipo:='Reta';
     nome:=_nome;
     pi:=_pi;
     pf:=_pf;
end;

destructor TReta.destrua_se;
begin
end;

procedure TReta.escalona(origem: boolean; sx, sy, sz: real);
var
 dx,dy,dz : real;
begin
  if not origem then begin
    dx:=(pi.x+pf.x)/2;
    dy:=(pi.y+pf.y)/2;
    dz:=(pi.z+pf.z)/2;
    translada(-dx,-dy,-dz);
  end;
  pi.escalona(true,sx,sy,sz);
  pf.escalona(true,sx,sy,sz);
  if not origem then translada(dx,dy,dz);
end;

procedure TReta.rotacao(tipoRotacao, eixoRotacao, angulo: integer);
var
 dx,dy,dz : real;
begin
  if tipoRotacao=2 then begin //sobre o centro do objeto
    dx:=(pi.x+pf.x)/2;
    dy:=(pi.y+pf.y)/2;
    dz:=(pi.z+pf.z)/2;
    translada(-dx,-dy,-dz);
  end;
  pi.rotacao(0, eixoRotacao, angulo);
  pf.rotacao(0, eixoRotacao, angulo);
  if tipoRotacao=2 then translada(dx,dy,dz);
end;

procedure TReta.translada(dx, dy, dz: real);
begin
  pi.translada(dx,dy,dz);
  pf.translada(dx,dy,dz);
end;

end.
