unit uWindow;

interface

uses SysUtils;
type
  TWindow = class
  private
    function verificaLimites : boolean;
    function getErro: boolean;
    function getXmax: real;
    function getXmin: real;
    function getYmax: real;
    function getYmin: real;
    procedure setErro(valor: boolean);
    procedure setXmax(valor: real);
    procedure setXmin(valor: real);
    procedure setYmax(valor: real);
    procedure setYmin(valor: real);

   public
    destructor destrua_se;
    constructor crie_se(_xmin, _xmax, _ymin, _ymax:REAL);

  published
    property xmin:real read getXmin write setXmin;
    property xmax:real read getXmax write setXmax;
    property ymin:real read getYmin write setYmin;
    property ymax:real read getYmax write setYmax;
    property erro:boolean read getErro write setErro;
 end;

implementation

var
     verro: boolean;
     vxmin: real;
     vxmax: real;
     vymin: real;
     vymax: real;

constructor TWindow.crie_se(_xmin,_xmax,_ymin, _ymax:real);
begin
     verro:=false;
     vxmin:=_xmin;
     vxmax:=_xmax;
     vymin:=_ymin;
     vymax:=_ymax;
end;

destructor TWindow.destrua_se;
begin
end;

function TWindow.verificaLimites : boolean;
begin
 verro:= (xmax-xmin<50) or (ymax- ymin<+50);
 result:=verro;
end;

function TWindow.getXmin: real;
begin
 result:=vxmin;
end;

function TWindow.getXmax: real;
begin
 result:=vxmax;
end;

function TWindow.getYmin: real;
begin
 result:=vymin;
end;

function TWindow.getYmax: real;
begin
 result:=vymax;
end;

procedure TWindow.setXmax(valor: real);
begin
 vxmax:=valor;
 verificaLimites;
end;

procedure TWindow.setXmin(valor: real);
begin
 vxmin:=valor;
 verificaLimites;
end;

procedure TWindow.setYmax(valor: real);
begin
 vymax:=valor;
 verificaLimites;
end;

procedure TWindow.setYmin(valor: real);
begin
 vymin:=valor;
 verificaLimites;
end;

function TWindow.getErro: boolean;
begin
 result:=verro;
end;

procedure TWindow.setErro(valor: boolean);
begin
 verro:=valor;
end;

end.
